.386
.model flat,stdcall
option casemap:none

include filefunc.inc

PUBLIC  ReadFileToMem@12

.code

;   ReadFileToMem PROC pFileName:DWORD,pMem:DWORD,pNumbOfBytesRead:DWORD

;   pFileName           :  pointer to name of the file
;   pMem                :  pointer receiving the memory block allocated to read the input file
;   pNumbOfBytesRead    :  pointer receiving the number of bytes read

;   Return value        :  if the function succeeds, the return value is 3 
;                          if the function fails, the return value contains an error code                      


ReadFileToMem@12:

    sub     esp,4*4                                                 ; reserve 12 bytes for local variables
    
    invoke  CreateFile,DWORD PTR [esp+44],GENERIC_READ,0,0,\
            OPEN_EXISTING,FILE_ATTRIBUTE_ARCHIVE,0                  ; open file
    cmp     eax,INVALID_HANDLE_VALUE
    je      _exit2
@@:
    mov     DWORD PTR [esp+12],eax
    invoke  GetFileSize,eax,0
    mov     DWORD PTR [esp],eax
    invoke  VirtualAlloc,0,eax,MEM_COMMIT,PAGE_READWRITE            ; allocate memory
    test    eax,eax
    jnz     @f
    invoke  CloseHandle,DWORD PTR [esp+12]
    mov     eax,1
    jmp     _exit2
@@:
    mov     DWORD PTR [esp+8],eax
    mov     edx,DWORD PTR [esp+24]
    mov     DWORD PTR [edx],eax

    lea     edx,[esp+4]
    invoke  ReadFile,DWORD PTR [esp+28],eax,DWORD PTR [esp+8],edx,0 ; read file
    test    eax,eax
    jnz     @f
    invoke  CloseHandle,DWORD PTR [esp+12]
    mov     eax,2
    jmp     _exit1
@@:
    mov     edx,DWORD PTR [esp+28]
    mov     eax,DWORD PTR [esp+4]
    mov     DWORD PTR [edx],eax
    invoke  CloseHandle,DWORD PTR [esp+12]                          ; close file
    test    eax,eax
    jz      _exit1
    mov     eax,3
    jmp     _exit2
    
_exit1:

    push    eax
    invoke  VirtualFree,DWORD PTR [esp+12],0,MEM_RELEASE            ; release the allocated memory if there was
    pop     eax                                                     ; an error while reading the file
                                                                    ; or closing the handle
_exit2:    

    add     esp,4*4                                                 ; balance the stack manually
    ret     3*4                                                     ; release the three parameters and return back    
                                                                    ; to the main module
;   ENDP ReadFileToMem

END

